{% extends "ajax/ajax.html.twig" %}
{% block ajax %}
    {% macro valuelist(prop,val) %}
        <div class="row">
            <div class="cell rw-4"><b>{{ prop }}</b></div>
            <div class="cell rw-8">
                {% if val is same as(true) %}
                    {{ 'Ja'|trans({},'admin') }}
                {% elseif val is same as(false)  %}
                    {{ 'Nein'|trans({},'admin') }}
                {% else %}
                    {{ val }}
                {% endif %}
            </div>
        </div>
    {% endmacro %}

    <div class="row">
        <div class="cell padded rw-12">
            <ul class="tabs plain" x-tab-group="admin-town" x-tab-control x-tab-default="dash">
                <li class="tab" x-tab-id="dash"><div class="tab-link">{{ 'Übersicht'|trans({},'admin') }}</div></li>
                <li class="tab" x-tab-id="citizens"><div class="tab-link">{{ 'Bürger'|trans({},'admin') }}</div></li>
                <li class="tab" x-tab-id="register"><div class="tab-link">{{ 'Stadtregister'|trans({},'admin') }}</div></li>
                <li class="tab" x-tab-id="estimations"><div class="tab-link">{{ 'Admin-Wachturm'|trans({},'admin') }}</div></li>
                {% if is_granted("ROLE_ADMIN") %}
                    <li class="tab" x-tab-id="explorer"><div class="tab-link">{{ 'Ruinenscanner'|trans({},'admin') }}</div></li>
                {% endif %}

            </ul>
            {# @var town \App\Entity\Town #}
            <div x-tab-group="admin-town" x-tab-id="dash" x-tab-target>
                <div class="row">
                    <div class="cell padded rw-6 rw-sm-12">
                        {{ _self.valuelist('ID'|trans({},'admin'),         town.id) }}
                        {{ _self.valuelist('Stadtname'|trans({},'admin'),  town.name) }}
                        {{ _self.valuelist('Sprache'|trans({},'admin'),    town.language) }}
                        {{ _self.valuelist('Typ'|trans({},'admin'),        town.type.label|trans({},'game')) }}
                        {{ _self.valuelist('Population'|trans({},'admin'), town.population) }}
                        {{ _self.valuelist('Saison'|trans({},'admin'),     town.season ? town.season.number : '--') }}
                        {{ _self.valuelist('Tag'|trans({},'admin'),        town.day) }}
                        {{ _self.valuelist('Offen'|trans({},'admin'),      town.open) }}
                        {{ _self.valuelist('Chaos'|trans({},'admin'),      town.chaos) }}
                        {{ _self.valuelist('Zerstört'|trans({},'admin'),   town.devastated) }}
                        {{ _self.valuelist('Tor offen'|trans({},'admin'),  town.door) }}
                        {{ _self.valuelist('Brunnen'|trans({},'admin'),    town.well) }}
                        {{ _self.valuelist('Quarantäne'|trans({},'game'),  town.attackFails >= 3) }}

                        <div class="row">
                            <div class="cell rw-4"><b><label for="administer-town">{{ 'Stadt administrieren'|trans({},'admin') }}</label></b></div>
                            <div class="cell rw-8">
                                <select id="administer-town" style="width: 30rem;">
                                    <option value="">-</option>
                                    {% if is_granted("ROLE_ADMIN") %}
                                        <optgroup label="{{ 'Nächtlicher Angriff'|trans({},'admin') }}">
                                            {% if town.attackFails >= 3 %}
                                                <option value="{{ url('admin_town_manage', {action: 'release', id: town.id}) }}">{{ 'Quarantäne aufheben'|trans({},'admin') }}</option>
                                            {% else %}
                                                <option value="{{ url('admin_town_manage', {action: 'quarantine', id: town.id}) }}">{{ 'Unter Quarantäne stellen'|trans({},'admin') }}</option>
                                            {% endif %}
                                            {% if not town.open %}
                                                <option value="{{ url('admin_town_manage', {action: 'advance', id: town.id}) }}">{{ 'Manueller Tageswechsel'|trans({},'admin') }}</option>
                                            {% endif %}
                                        </optgroup>
                                    <optgroup label="{{ 'Verwaltung'|trans({},'admin') }}">
                                        <option x-alt-url="{{ path('admin_town_list') }}" value="{{ url('admin_town_manage', {action: 'nullify', id: town.id}) }}">{{ 'Annulieren'|trans({},'admin') }}</option>
                                    </optgroup>
                                    {% endif %}
                                </select>
                                <div id="execute_button" class="button inline small">{{ 'Ausführen'|trans({},'admin') }}</div>
                            </div>
                        </div>
                    </div>
                    <div class="cell padded rw-6 rw-sm-12">
                        {% embed "ajax/admin/towns/map.html.twig" with {'default_zoom': 0, 'default_show_zone': false, 'allow_zone_view': false, 'map': map_data} %}
                        {% endembed %}
                    </div>
                </div>
            </div>

            <div x-tab-group="admin-town" x-tab-id="citizens" x-tab-target>
                <div class="row">
                    <div class="cell rw-8 ro-2 padded">
                        <button id="townpm" style="width: 30rem;">{{ 'Rundmail als Rabe'|trans({},'admin') }}</button>
                        <input type="hidden" id="pmidrecipient" value="{{ town.id }}">
                        <div id="forum-content">

                        </div>
                    </div>
                </div>
            </div>

            <div x-tab-group="admin-town" x-tab-id="register" x-tab-target>
                {% embed "ajax/game/log.html.twig" with {'log_content': log, 'log_source': path('admin_newspaper_log_controller') } %}
                {% endembed %}
            </div>

            <div x-tab-group="admin-town" x-tab-id="estimations" x-tab-target>
                <div class="row-table">
                    <div class="row header">
                        <div class="cell rw-1 padded"></div>
                        <div class="cell rw-1 padded">{{ 'ID'|trans({},'admin') }}</div>
                        <div class="cell rw-1 padded">{{ 'Tag'|trans({},'admin') }}</div>
                        <div class="cell rw-2 padded">{{ 'Angriff'|trans({},'admin') }}</div>
                        <div class="cell rw-2 padded">{{ 'Bereich Min'|trans({},'admin') }}</div>
                        <div class="cell rw-2 padded">{{ 'Bereich Max'|trans({},'admin') }}</div>
                    </div>
                    {% for est in town.zombieEstimations %}
                        <div class="row {% if est.day == town.day %}bold{% endif %}">
                            <div class="padded cell rw-1">{% if est.day == town.day %}<i class="fa fa-arrow-right"></i>{% endif %}</div>
                            <div class="padded cell rw-1">{{ est.id }}</div>
                            <div class="padded cell rw-1">{{ est.day }}</div>
                            {% if is_granted("ROLE_ADMIN") or est.day < town.day %}
                                <div class="padded cell rw-2">{{ est.zombies }}</div>
                                <div class="padded cell rw-2">{{ est.offsetMin }}%</div>
                                <div class="padded cell rw-2">{{ est.offsetMax }}%</div>
                            {% endif %}
                        </div>
                    {% endfor %}
                </div>
            </div>

            {% if is_granted("ROLE_ADMIN") %}
                <div x-tab-group="admin-town" x-tab-id="explorer" x-tab-target>
                    {% for exploration in explorables %}
                        <div class="row">
                            <div class="cell rw-6 padded">
                                <h5>{{ exploration.z.prototype.label|trans({},'game') }} - {{ exploration.z.x }}/{{ exploration.z.y }}</h5>
                                <div class="adm-exploration">
                                    {% for rz in exploration.rz %}
                                        <div class="rz {% if rz.prototype %}rz-{{ rz.locked ? 'locked' : 'unlocked' }}{% endif%} rz-{{ rz.distance > conf.get(constant('App\\Structures\\TownConf::CONF_EXPLORABLES_LOCKDIST')) ? 'far' : 'close' }} rz-{{ rz.corridor }} {% if rz.zombies > 0 %}rz-zeds{% endif %}" style="top:{{ rz.y * 20 }}px;left:{{ rz.x * 20 }}px;">
                                            {% if rz.corridor != 0 %}
                                                <div class="tooltip ndynamic">
                                                    {{ _self.valuelist('ID'|trans({},'admin'), rz.id) }}
                                                    {{ _self.valuelist('Position'|trans({},'admin'), rz.x ~ ' / ' ~ rz.y) }}
                                                    {{ _self.valuelist('Distanz'|trans({},'admin'), rz.distance) }}
                                                    {{ _self.valuelist('Zombies'|trans({},'admin'), rz.zombies) }}
                                                    {% if rz.prototype %}
                                                        {% if rz.locked %}
                                                            {{ _self.valuelist('Abdruck'|trans({},'admin'), rz.prototype.keyImprint.label|trans({},'items')) }}
                                                            {{ _self.valuelist('Schlüssel'|trans({},'admin'), rz.prototype.keyItem.label|trans({},'items')) }}
                                                        {% else %}
                                                            {{ _self.valuelist('Durchsucht'|trans({},'admin'), rz.digs) }}
                                                        {% endif %}
                                                    {% endif %}
                                                </div>
                                            {% endif %}
                                        </div>
                                    {% endfor %}
                                </div>
                            </div>
                            <div class="cell rw-6 padded">
                                <h5>{{ 'Aktuelle Sitzung'|trans({},'admin') }}</h5>
                                {% if exploration.ax %}
                                    {{ _self.valuelist('Spieler'|trans({},'admin'), exploration.ax.citizen.user.name) }}
                                    {{ _self.valuelist('Position'|trans({},'admin'), exploration.ax.x ~ ' / ' ~ exploration.ax.y ) }}
                                    {{ _self.valuelist('Flucht'|trans({},'admin'), exploration.ax.escaping ) }}
                                    {{ _self.valuelist('Raum'|trans({},'admin'), exploration.ax.inRoom ) }}
                                    <div class="row">
                                        <div class="cell rw-4"><b>{{ 'Zeit'|trans({},'admin') }}</b></div>
                                        <div class="cell rw-8"><span x-countdown="{{ exploration.axt }}">...</span></div>
                                    </div>
                                {% endif %}
                                <h5>{{ 'Alle Sitzungen'|trans({},'admin') }}</h5>
                                {% for x in exploration.x %}
                                    <div>{{ x.citizen.user.name }}</div>
                                {% endfor %}
                            </div>
                        </div>
                    {% endfor %}
                </div>
            {% endif %}

            <br />
            <div class="row">
                <div class="cell rw-3 ro-9">
                    <button x-ajax-href="{{ path('admin_town_list') }}">{{ 'Stadtübersicht'|trans({},'admin') }}</button>
                </div>
            </div>
        </div>


    </div>


{% endblock %}
{% block js %}
    <script>
        (function() {

            document.getElementById('execute_button').addEventListener('click', function() {
                if (!document.getElementById('administer-town').value) return;
                let url = document.querySelector('#administer-town option:checked').getAttribute('x-alt-url');
                $.ajax.easySend( document.getElementById('administer-town').value, {},
                    function () {
                        $.ajax.load(null, url ? url : '{{ path('admin_town_explorer', {id: town.id}) }}', true);
                    } );
            });

            document.getElementById('townpm').addEventListener('click', function(e) {
                document.getElementById("forum-content").innerHTML = "";
                $.ajax.no_history().load( document.getElementById('forum-content'), '{{ path('admin_pm_editor_controller', {'type': 'global'}) }}', false )
            });

            let log_boxes = document.querySelectorAll('.log-container');
            for (let i = 0; i < log_boxes.length; i++) {
                let log = log_boxes[i].querySelector( '.log' );

                const has_preloaded_content = log.getAttribute('x-log-default-provided') == '1';
                const url = log.getAttribute('x-log-source');
                let content_box = log.querySelectorAll('.log-content');

                const fun_refresh = function(d,bg) {
                    if (bg) $.ajax.background().load( content_box[0], url, false, {day: d, town: {{town.id}}} );
                    else $.ajax.load( content_box[0], url, false, {day: d, town: {{town.id}}} )
                };

                let refresh_button = log.querySelector('.log-complete-link');
                if (refresh_button) refresh_button.addEventListener('click', function() {
                    let spinner = log.querySelector('.log-spinner');
                    refresh_button.classList.add('hidden');
                    if (spinner) spinner.classList.remove('hidden');

                    fun_refresh(-1,true);
                });

                if (!has_preloaded_content) fun_refresh(-1,true);

                let control_tab = log_boxes[i].querySelector( '.log-day-select .tab' );
                if (control_tab) {
                    const min = parseInt(control_tab.getAttribute( 'x-page-min' ));
                    const max = parseInt(control_tab.getAttribute( 'x-page-max' ));
                    let   cur = parseInt(control_tab.getAttribute( 'x-page-current' ));

                    let control_fwd = control_tab.querySelector( 'div.control:first-child' );
                    let control_bwd = control_tab.querySelector( 'div.control:last-child' );
                    let label       = control_tab.querySelector( 'span' );

                    const fun_adjust = function(dif) {
                        if ((dif > 0 && cur <= (max-dif)) || (dif < 0 && cur >= (min-dif))) {
                            cur += dif;
                            label.innerText = ('' + cur);
                            fun_refresh(cur,false);
                        }
                    };

                    control_fwd.addEventListener('click', function() { fun_adjust( 1) });
                    control_bwd.addEventListener('click', function() { fun_adjust(-1) });
                }
            }
        })();

    </script>
{% endblock %}